<script lang="ts" setup>
import { computed, defineEmits } from 'vue'

interface ApiData {
  id: string
  model: string
  created: number
  choices: {
    index: number
    message: {
      role: string
      content: string
    }
    finish_reason: string
  }[]
  usage: {
    prompt_tokens: number
    completion_tokens: number
    total_tokens: number
  }
}

const props = defineProps<{
  apiData?: ApiData
}>()

// Definir los eventos que el componente puede emitir
const emit = defineEmits(['close'])

// Valores predeterminados
const defaultApiData: ApiData = {
  id: 'default-id',
  model: 'default-model',
  created: Date.now() / 1000, // Fecha actual en segundos UNIX
  choices: [{
    index: 0,
    message: {
      role: 'assistant',
      content: 'Contenido predeterminado',
    },
    finish_reason: 'stop',
  }],
  usage: {
    prompt_tokens: 0,
    completion_tokens: 0,
    total_tokens: 0,
  },
}

// Uso de computed para manejar valores predeterminados si props.apiData no está definido
const apiData = computed(() => {
  return props.apiData ?? defaultApiData
})

function formatDate(timestamp: number): string {
  const date = new Date(timestamp * 1000) // Convertir el timestamp a milisegundos

  return `${date.toLocaleDateString('es-ES')} ${date.toLocaleTimeString('es-ES')}`
}

const onClose = () => {
  emit('close')
}
</script>

<template>
  <VContainer>
    <VRow>
      <VCol>
        <!-- Close Button -->
        <div class="pt-2 me-2 text-end">
          <IconBtn @click="onClose">
            <VIcon
              class="text-medium-emphasis"
              color="disabled"
              icon="tabler-x"
            />
          </IconBtn>
        </div>

        <VCard>
          <VCardTitle class="text-sm text-disabled">
            API Details
          </VCardTitle>
          <VCardText>
            <div><strong>ID:</strong> {{ apiData.id }}</div>
            <div><strong>Model:</strong> {{ apiData.model }}</div>
            <div><strong>Creation Date:</strong> {{ formatDate(apiData.created) }}</div>
            <div><strong>Finished Reason:</strong> {{ apiData.choices[0].finish_reason }}</div>
          </VCardText>

          <VCardTitle class="text-sm text-disabled">
            Usage Details
          </VCardTitle>
          <VCardText class="small-section">
            <div><strong>Prompt Tokens:</strong> {{ apiData.usage.prompt_tokens }}</div>
            <div><strong>completionTokens:</strong> {{ apiData.usage.completion_tokens }}</div>
            <div><strong>Total Tokens:</strong> {{ apiData.usage.total_tokens }}</div>
          </VCardText>
        </VCard>
      </VCol>
    </VRow>
  </VContainer>
</template>
